 /****************
 	This code depends on macro globals and possible data sets exst exen created by the %TREATMENTEMERGENT macro in CDISCPARMS
 	It will create a new data set PatientDays that has the StartDY EndDY and patient duration in days (PatientDays) between variables 
 	representing duration of exposure or duration of study for each subject as determined the the TREATEMENTEMERGENT macro
 	
 	This should be called right after TreatmentEmergent if you want patient duration for each subject for using in incidence risks or time to event
 ****************/
 %if ^%symexist(IRTrtOffset) %then %do;
 	%global IRTrtOffset;
 	%let IRTrtOffset = 0;
 %end;
 
%macro CreatePatientDays;
 %if &TEAEVARDOMs ^= EX and &TEAEVARDOMe ^= EX %then %do;
	data patientDaysDT;
		set &in_adsl (keep = USUBJID &TEAEVARFLAGs &TEAEVARFLAGe);
		%if &TEAEVARFlAGs = TRTSDTM %then %do;
			StartDY = TRTSDTM/60/60/24;
		%end;
		%else %if &TEAEVARFlAGs = TRTSDT %then %do;
			StartDY = TRTSDT;
		%end;
		%else %do;
			%DATE9(var=&TEAEVarFLAGs, return=StartDay);
			%Time5(var=&TEAEVarFLAGs, return=StartTime);
			if missing(StartTime) then StartDy = StartDay;
			else StartDY = (StartDay + (StartTime/60/60/24));
		%end;
		%if &TEAEVARFlAGe = TRTEDTM %then %do;
			EndDY =TRTEDTM/60/60/24;
		%end;
		%else %if &TEAEVARFlAGe = TRTEDT %then %do;
			EndDY = TRTEDT;
		%end;					
		%else %do;
			%DATE9(var=&TEAEVarFLAGe, return=EndDaY);
			%Time5(var=&TEAEVarFLAGe, return=EndTime);
			if missing(EndTime) then EndDY = EndDay;
			else EndDY = (EndDay+(EndTime/60/60/24));
		%end;
		Offset = &IRTrtOffset;	
		_fracST_ = StartDY - floor(StartDY);
		_fracEN_ = EndDY - floor(EndDY);
		/* kemicl if either start or end is time based, do not add one to account for day rounding */
		if (_fracST_>0 or _fracEN_ >0) then PatientDays = (EndDY+Offset) - StartDY;
		else PatientDays = (EndDY+Offset) - StartDY +1;
		drop _fracST_ _fracEN_;
	run;
 %end;
 %else %do;
	 %if &TEAEVARDOMs = EX %then %do;
		data sday;
			set exst(keep = USUBJID &TEAEVARFLAGs) ;
			%DATE9(var=&TEAEVarFLAGs, return=StartDay);
			%Time5(var=&TEAEVarFLAGs, return=StartTime);
			if missing(StartTime) then StartDy = StartDay;
			else StartDY = (StartDay + (StartTime/60/60/24));
			keep USUBJID &TEAEVarFLAGs StartDY;
		run;
	%end;
	%else %do;
		data sday;
			set &in_adsl (keep = USUBJID &TEAEVARFLAGs);
			%if &TEAEVARFlAGs = TRTSDTM %then %do;
				StartDY = TRTSDTM/60/60/24;
			%end;
			%else %if &TEAEVARFlAGs = TRTSDT %then %do;
				StartDY = TRTSDT;
			%end;
			%else %do;
				%DATE9(var=&TEAEVarFLAGs, return=StartDay);
				%Time5(var=&TEAEVarFLAGs, return=StartTime);
				if missing(StartTime) then StartDy = StartDay;
				else StartDY = (StartDay + (StartTime/60/60/24));
			%end;
			keep USUBJID &TEAEVarFLAGs StartDY;
		run;				
	%end;
	%if &TEAEVARDOMe = EX %then %do;
		data eday;
			set exen(keep = USUBJID &TEAEVARFLAGe) ;
			%DATE9(var=&TEAEVarFLAGe, return=EndDaY);
			%Time5(var=&TEAEVarFLAGe, return=EndTime);
			if missing(EndTime) then EndDY = EndDay;
			else EndDY = (EndDay+(EndTime/60/60/24));
			keep USUBJID  &TEAEVarFLAGe EndDY;
		run;
	%end;
	%else %do;
		data eday;
			set &in_adsl (keep = USUBJID &TEAEVARFLAGe);
			%if &TEAEVARFlAGe = TRTEDTM %then %do;
				EndDY =TRTEDTM/60/60/24;
			%end;
			%else %if &TEAEVARFlAGe = TRTEDT %then %do;
				EndDY = TRTEDT;
			%end;					
			%else %do;
				%DATE9(var=&TEAEVarFLAGe, return=EndDaY);
				%Time5(var=&TEAEVarFLAGe, return=EndTime);
				if missing(EndTime) then EndDY = EndDay;
				else EndDY = (EndDay+(EndTime/60/60/24));
			%end;
			keep USUBJID &TEAEVarFLAGe EndDY;						
		run;
	 %end;				
	 data patientDaysDT;
		 merge sday eday;
		 by USUBJID;
		 Offset = &IRTrtOffset; 
		_fracST_ = StartDY - floor(StartDY);
		_fracEN_ = EndDY - floor(EndDY);
		if (_fracST_>0 or _fracEN_ >0) then PatientDays = (EndDY+Offset) - StartDY;
		else PatientDays = (EndDY+Offset) - StartDY +1;
		drop _fracST_ _fracEN_;
	 run;
 %end;
%mend;
%CreatePatientDays;