
/************************ PRODUCT VALIDATION  ******************
 *
 *      NAME: FindingsWaterfallPlots_LB001.sas
 *    REPORT: Laboratory Test Results Waterfall Plots JMPC 7.1
 *   PURPOSE: Laboratory Test Results Waterfall Plots Validation Program for Nicardipine study
 *   DEFECTS: 
 *     NOTES: Actual treatment, Change from baseline, Mean summary statistic
 *     Notes: SAFETY POPULATION
 *     NOTES: Same Results as JMPC for Nicardipine study 
 *****************************************************************/
title1 'FindingsWaterfallPlots_LB001.sas: Laboratory Test Results Waterfall Plots Validation Program';
title2 'Use Actual treatment, change from baseline, mean summary statistic';


*** Bring in datasets ***;
libname sdtm "&SDTMPATH";
libname adam "&ADAMPATH";

*** Subset ADSL on safety population ***;
data adsl;
 set adam.adsl;
 where saffl='Y' and trt01p ne 'Screen Failure';
run;

data lb;
 set sdtm.lb;
run;

*** Merge ADSL and LB ***;
data adsl_lb;
 merge adsl(in=a) lb(in=b);
 by usubjid;
 if a & b;
run;

*** Get baseline ***;
proc sort data=adsl_lb out=base; by usubjid lbtestcd lbdtc; where lbblfl='Y'; run;
data base2;
 set base;
 by usubjid lbtestcd lbdtc;
 if last.lbtestcd;
 keep usubjid lbtestcd lbstresn;
 rename lbstresn = base;
run;

*** Merge baseline back in ***;
proc sort data=adsl_lb; by usubjid lbtestcd; run;
data adsl_lb2;
 merge adsl_lb base2;
 by usubjid lbtestcd;
 chg = lbstresn - base;
 if lbdy>0 and lbblfl ne 'Y';
run;

*** Get mean per subject per lab test ***;
proc sort data=adsl_lb2; by lbtest lbtestcd usubjid; run;
proc means data=adsl_lb2 noprint;
 by lbtest lbtestcd usubjid trt01p;
 var chg;
 output out=meanvals mean=mean_chg;
run;

data meanvals2;
 set meanvals;
 label mean_chg = "Change from Baseline";
 drop _type_ _freq_;
run;

libname outdata "&OUTPUTD";
data outdata.FindingsWaterfallPlots_LB001;
 set meanvals2;
run;
